searchData={"items":[{"type":"module","title":"Backfish","doc":"Backfish is a flexible and powerful backtracking library for Elixir, designed\nto solve combinatorial and constraint satisfaction problems.","ref":"Backfish.html"},{"type":"function","title":"Backfish.find_all_solutions/2","doc":"Finds all solutions to the given problem.","ref":"Backfish.html#find_all_solutions/2"},{"type":"function","title":"Parameters - Backfish.find_all_solutions/2","doc":"- `problem_module`: The module implementing the problem definition using\n    `Backfish.ProblemDefinition`.\n  - `opts`: Optional keyword list of options. Supports:\n    - `:args`: Arguments to pass to the `initial_state/1` function of the\n      problem module.\n    - `:depth_limit`: Optional limit on the depth of the search.","ref":"Backfish.html#find_all_solutions/2-parameters"},{"type":"function","title":"Examples - Backfish.find_all_solutions/2","doc":"iex> opts = [args: [size: 8]]\n    iex> Backfish.find_all_solutions(Backfish.Examples.NQueens, opts)\n    [solution1, solution2, ...]","ref":"Backfish.html#find_all_solutions/2-examples"},{"type":"function","title":"Backfish.find_first_solution/2","doc":"Finds the first valid solution to the given problem.","ref":"Backfish.html#find_first_solution/2"},{"type":"function","title":"Parameters - Backfish.find_first_solution/2","doc":"- `problem_module`: The module implementing the problem definition using\n    `Backfish.ProblemDefinition`.\n  - `opts`: Optional keyword list of options. Supports:\n    - `:args`: Arguments to pass to the `initial_state/1` function of the\n      problem module.\n    - `:depth_limit`: Optional limit on the depth of the search.","ref":"Backfish.html#find_first_solution/2-parameters"},{"type":"function","title":"Examples - Backfish.find_first_solution/2","doc":"iex> opts = [args: [size: 8]]\n    iex> {:ok, solution} = Backfish.find_first_solution(Backfish.Examples.NQueens, opts)\n    {:ok, solution}","ref":"Backfish.html#find_first_solution/2-examples"},{"type":"module","title":"Backfish.Examples.EightPuzzle","doc":"An implementation of the 8-puzzle problem using the Backfish backtracking\nlibrary.\n\nThe 8-puzzle consists of a 3x3 grid with 8 numbered tiles and one empty\nspace. The goal is to move the tiles around to achieve a specific end\nconfiguration.","ref":"Backfish.Examples.EightPuzzle.html"},{"type":"function","title":"Backfish.Examples.EightPuzzle.initial_state/1","doc":"Returns the initial state of the 8-puzzle problem.","ref":"Backfish.Examples.EightPuzzle.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.EightPuzzle.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:board` which is a 2D list\n    representing the initial board configuration.","ref":"Backfish.Examples.EightPuzzle.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.EightPuzzle.initial_state/1","doc":"- A map representing the initial state, including the board and a set of\n    visited states.","ref":"Backfish.Examples.EightPuzzle.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.EightPuzzle.is_goal?/1","doc":"Checks if the given state is the goal state.","ref":"Backfish.Examples.EightPuzzle.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.EightPuzzle.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration.","ref":"Backfish.Examples.EightPuzzle.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.EightPuzzle.is_goal?/1","doc":"- `true` if the board is in the goal configuration, `false` otherwise.","ref":"Backfish.Examples.EightPuzzle.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.EightPuzzle.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.EightPuzzle.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.EightPuzzle.next_steps/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration and the set of visited states.","ref":"Backfish.Examples.EightPuzzle.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.EightPuzzle.next_steps/1","doc":"- A list of the next possible states, each including the new board\n    configuration and updated visited states.","ref":"Backfish.Examples.EightPuzzle.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.GraphColoring","doc":"An implementation of the graph coloring problem using the Backfish backtracking\nlibrary.\n\nThe graph coloring problem involves assigning colors to the vertices of a graph\nsuch that no two adjacent vertices share the same color. The objective is to\nuse the minimum number of colors.","ref":"Backfish.Examples.GraphColoring.html"},{"type":"function","title":"Backfish.Examples.GraphColoring.initial_state/1","doc":"Returns the initial state of the graph coloring problem.","ref":"Backfish.Examples.GraphColoring.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.GraphColoring.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:graph`, which is a map\n    representing the graph where keys are nodes and values are lists of\n    adjacent nodes, and `:colors`, which is the number of colors available\n    (default is 3).","ref":"Backfish.Examples.GraphColoring.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.GraphColoring.initial_state/1","doc":"- A map representing the initial state, including the graph, the number of\n    colors, and an empty color assignment.","ref":"Backfish.Examples.GraphColoring.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.GraphColoring.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.GraphColoring.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.GraphColoring.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the graph and\n    the color assignment.","ref":"Backfish.Examples.GraphColoring.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.GraphColoring.is_goal?/1","doc":"- `true` if all nodes in the graph have been assigned a color, `false`\n    otherwise.","ref":"Backfish.Examples.GraphColoring.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.GraphColoring.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.GraphColoring.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.GraphColoring.next_steps/1","doc":"- `state`: The current state of the problem, which includes the graph, the\n    number of colors, and the color assignment.","ref":"Backfish.Examples.GraphColoring.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.GraphColoring.next_steps/1","doc":"- A list of the next possible states, each including a new color assignment\n    with one additional node colored.","ref":"Backfish.Examples.GraphColoring.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.HamiltonianPath","doc":"An implementation of the Hamiltonian path problem using the Backfish\nbacktracking library.\n\nThe Hamiltonian path problem involves finding a path in an undirected or\ndirected graph that visits each vertex exactly once.","ref":"Backfish.Examples.HamiltonianPath.html"},{"type":"function","title":"Backfish.Examples.HamiltonianPath.initial_state/1","doc":"Returns the initial state of the Hamiltonian path problem.","ref":"Backfish.Examples.HamiltonianPath.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.HamiltonianPath.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:graph`, which is a map\n    representing the graph where keys are nodes and values are lists of\n    adjacent nodes, and `:start_node`, which is the starting node for the\n    path.","ref":"Backfish.Examples.HamiltonianPath.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.HamiltonianPath.initial_state/1","doc":"- A map representing the initial state, including the graph, the initial\n    path with the starting node, and a set of visited nodes.","ref":"Backfish.Examples.HamiltonianPath.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.HamiltonianPath.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.HamiltonianPath.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.HamiltonianPath.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the graph, the\n    path, and the set of visited nodes.","ref":"Backfish.Examples.HamiltonianPath.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.HamiltonianPath.is_goal?/1","doc":"- `true` if the number of visited nodes equals the number of nodes in the\n    graph, `false` otherwise.","ref":"Backfish.Examples.HamiltonianPath.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.HamiltonianPath.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.HamiltonianPath.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.HamiltonianPath.next_steps/1","doc":"- `state`: The current state of the problem, which includes the graph, the\n    path, and the set of visited nodes.","ref":"Backfish.Examples.HamiltonianPath.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.HamiltonianPath.next_steps/1","doc":"- A list of the next possible states, each including a new path with an\n    additional node visited.","ref":"Backfish.Examples.HamiltonianPath.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.Knapsack","doc":"An implementation of the knapsack problem using the Backfish backtracking\nlibrary.\n\nThe knapsack problem involves selecting a subset of items, each with a weight\nand a value, to include in a knapsack so that the total weight does not\nexceed the capacity of the knapsack and the total value is maximized.","ref":"Backfish.Examples.Knapsack.html"},{"type":"function","title":"Backfish.Examples.Knapsack.initial_state/1","doc":"Returns the initial state of the knapsack problem.","ref":"Backfish.Examples.Knapsack.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.Knapsack.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:items`, which is a list of\n    tuples representing the items (each tuple contains a value and a weight),\n    and `:capacity`, which is the capacity of the knapsack.","ref":"Backfish.Examples.Knapsack.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Knapsack.initial_state/1","doc":"- A map representing the initial state, including the items, capacity,\n    current weight, current value, and a list indicating which items are\n    included in the knapsack.","ref":"Backfish.Examples.Knapsack.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.Knapsack.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.Knapsack.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.Knapsack.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the items and\n    the list of included items.","ref":"Backfish.Examples.Knapsack.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Knapsack.is_goal?/1","doc":"- `true` if the number of included items equals the total number of items,\n    `false` otherwise.","ref":"Backfish.Examples.Knapsack.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.Knapsack.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.Knapsack.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.Knapsack.next_steps/1","doc":"- `state`: The current state of the problem, which includes the items,\n    capacity, current weight, current value, and the list of included items.","ref":"Backfish.Examples.Knapsack.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Knapsack.next_steps/1","doc":"- A list of the next possible states, each including a new item either\n    included or excluded.","ref":"Backfish.Examples.Knapsack.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.NQueens","doc":"An implementation of the N-Queens problem using the Backfish backtracking\nlibrary.\n\nThe N-Queens problem involves placing N chess queens on an NxN chessboard so\nthat no two queens threaten each other. Thus, a solution requires that no\ntwo queens share the same row, column, or diagonal.","ref":"Backfish.Examples.NQueens.html"},{"type":"function","title":"Backfish.Examples.NQueens.initial_state/1","doc":"Returns the initial state of the N-Queens problem.","ref":"Backfish.Examples.NQueens.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.NQueens.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:size` which represents\n    the size of the board (default is 8).","ref":"Backfish.Examples.NQueens.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.NQueens.initial_state/1","doc":"- A map representing the initial state, including an empty board and the\n    board size.","ref":"Backfish.Examples.NQueens.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.NQueens.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.NQueens.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.NQueens.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration and the board size.","ref":"Backfish.Examples.NQueens.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.NQueens.is_goal?/1","doc":"- `true` if the number of queens on the board equals the size of the board,\n    `false` otherwise.","ref":"Backfish.Examples.NQueens.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.NQueens.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.NQueens.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.NQueens.next_steps/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration and the board size.","ref":"Backfish.Examples.NQueens.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.NQueens.next_steps/1","doc":"- A list of the next possible states, each including the new board\n    configuration with one additional queen placed.","ref":"Backfish.Examples.NQueens.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.Sudoku","doc":"An implementation of the Sudoku puzzle using the Backfish backtracking library.\n\nSudoku is a logic-based combinatorial number-placement puzzle. The objective\nis to fill a 9x9 grid with digits so that each column, each row, and each of\nthe nine 3x3 subgrids that compose the grid contain all of the digits from 1\nto 9.","ref":"Backfish.Examples.Sudoku.html"},{"type":"function","title":"Backfish.Examples.Sudoku.initial_state/1","doc":"Returns the initial state of the Sudoku puzzle.","ref":"Backfish.Examples.Sudoku.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.Sudoku.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:board` which is a 2D list\n    representing the initial board configuration.","ref":"Backfish.Examples.Sudoku.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Sudoku.initial_state/1","doc":"- A map representing the initial state, including the board and the board\n    size.","ref":"Backfish.Examples.Sudoku.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.Sudoku.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.Sudoku.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.Sudoku.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration and the board size.","ref":"Backfish.Examples.Sudoku.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Sudoku.is_goal?/1","doc":"- `true` if all cells in the board contain numbers from 1 to the board\n    size, `false` otherwise.","ref":"Backfish.Examples.Sudoku.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.Sudoku.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.Sudoku.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.Sudoku.next_steps/1","doc":"- `state`: The current state of the problem, which includes the board\n    configuration and the board size.","ref":"Backfish.Examples.Sudoku.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.Sudoku.next_steps/1","doc":"- A list of the next possible states, each including the new board\n    configuration with one additional number placed.","ref":"Backfish.Examples.Sudoku.html#next_steps/1-returns"},{"type":"module","title":"Backfish.Examples.WordSearch","doc":"An implementation of the word search puzzle using the Backfish backtracking\nlibrary.\n\nThe word search puzzle involves finding a list of words in a grid of letters.\nWords can be placed horizontally, vertically, or diagonally, and can be read\nforwards or backwards.","ref":"Backfish.Examples.WordSearch.html"},{"type":"function","title":"Backfish.Examples.WordSearch.initial_state/1","doc":"Returns the initial state of the word search puzzle.","ref":"Backfish.Examples.WordSearch.html#initial_state/1"},{"type":"function","title":"Parameters - Backfish.Examples.WordSearch.initial_state/1","doc":"- `args`: A keyword list of arguments. Expects `:board`, which is a 2D list\n    representing the letter grid, and `:words`, which is a list of words to\n    find in the grid.","ref":"Backfish.Examples.WordSearch.html#initial_state/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.WordSearch.initial_state/1","doc":"- A map representing the initial state, including the board, the list of\n    words, the found words, and the paths taken to find the words.","ref":"Backfish.Examples.WordSearch.html#initial_state/1-returns"},{"type":"function","title":"Backfish.Examples.WordSearch.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.Examples.WordSearch.html#is_goal?/1"},{"type":"function","title":"Parameters - Backfish.Examples.WordSearch.is_goal?/1","doc":"- `state`: The current state of the problem, which includes the list of\n    words and the found words.","ref":"Backfish.Examples.WordSearch.html#is_goal?/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.WordSearch.is_goal?/1","doc":"- `true` if all words have been found, `false` otherwise.","ref":"Backfish.Examples.WordSearch.html#is_goal?/1-returns"},{"type":"function","title":"Backfish.Examples.WordSearch.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.Examples.WordSearch.html#next_steps/1"},{"type":"function","title":"Parameters - Backfish.Examples.WordSearch.next_steps/1","doc":"- `state`: The current state of the problem, which includes the board, the\n    list of words, the found words, and the paths taken to find the words.","ref":"Backfish.Examples.WordSearch.html#next_steps/1-parameters"},{"type":"function","title":"Returns - Backfish.Examples.WordSearch.next_steps/1","doc":"- A list of the next possible states, each including the updated board,\n    the list of words, the updated list of found words, and the updated\n    paths.","ref":"Backfish.Examples.WordSearch.html#next_steps/1-returns"},{"type":"behaviour","title":"Backfish.ProblemDefinition","doc":"A behaviour module for defining problems that can be solved using the Backfish\nbacktracking library.\n\nThis module provides three callback functions that must be implemented by any\nmodule that uses it:\n- `initial_state/1`\n- `is_goal?/1`\n- `next_steps/1`\n\nThe `__using__` macro also defines default implementations for these callbacks\nthat raise errors, ensuring that any module using this behaviour implements its\nown versions of these functions.","ref":"Backfish.ProblemDefinition.html"},{"type":"callback","title":"Backfish.ProblemDefinition.initial_state/1","doc":"Returns the initial state of the problem.","ref":"Backfish.ProblemDefinition.html#c:initial_state/1"},{"type":"callback","title":"Parameters - Backfish.ProblemDefinition.initial_state/1","doc":"- `args`: A keyword list of arguments that can be used to customize the\n    initial state.","ref":"Backfish.ProblemDefinition.html#c:initial_state/1-parameters"},{"type":"callback","title":"Returns - Backfish.ProblemDefinition.initial_state/1","doc":"- The initial state of the problem.","ref":"Backfish.ProblemDefinition.html#c:initial_state/1-returns"},{"type":"callback","title":"Backfish.ProblemDefinition.is_goal?/1","doc":"Checks if the given state is a goal state.","ref":"Backfish.ProblemDefinition.html#c:is_goal?/1"},{"type":"callback","title":"Parameters - Backfish.ProblemDefinition.is_goal?/1","doc":"- `state`: The current state of the problem.","ref":"Backfish.ProblemDefinition.html#c:is_goal?/1-parameters"},{"type":"callback","title":"Returns - Backfish.ProblemDefinition.is_goal?/1","doc":"- `true` if the state is a goal state, `false` otherwise.","ref":"Backfish.ProblemDefinition.html#c:is_goal?/1-returns"},{"type":"callback","title":"Backfish.ProblemDefinition.next_steps/1","doc":"Generates the next possible states from the given state.","ref":"Backfish.ProblemDefinition.html#c:next_steps/1"},{"type":"callback","title":"Parameters - Backfish.ProblemDefinition.next_steps/1","doc":"- `state`: The current state of the problem.","ref":"Backfish.ProblemDefinition.html#c:next_steps/1-parameters"},{"type":"callback","title":"Returns - Backfish.ProblemDefinition.next_steps/1","doc":"- A list of the next possible states.","ref":"Backfish.ProblemDefinition.html#c:next_steps/1-returns"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2024 Andreas Donig\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Backfish","doc":"# Backfish\n\n**Backfish** is a flexible and powerful backtracking library for Elixir, designed to solve combinatorial and constraint satisfaction problems. Whether you're working on puzzles like Sudoku, N-Queens, Word Search, or graph problems like the Hamiltonian Path, Backfish provides the tools you need to implement efficient solutions.","ref":"readme.html"},{"type":"extras","title":"Features - Backfish","doc":"- Easy-to-use API for defining problem states, goals, and next steps.\n- Supports finding the first valid solution or all possible solutions.\n- Extensible to a wide variety of problem domains.","ref":"readme.html#features"},{"type":"extras","title":"Installation - Backfish","doc":"Add `backfish` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:backfish, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Backfish","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Defining a Problem - Backfish","doc":"To define a problem, you need to create a module that uses `Backfish.ProblemDefinition` and implements the required callbacks: `initial_state/1`, `is_goal?/1`, and `next_steps/1`.\n\n#### Example: N-Queens\n\n``` elixir\ndefmodule Backfish.Examples.NQueens do\n  use Backfish.ProblemDefinition\n\n  @default_size 8\n\n  def initial_state(args) do\n    size = Keyword.get(args, :size, @default_size)\n    %{board: [], size: size}\n  end\n\n  def is_goal?(%{board: board, size: size}) do\n    length(board) == size\n  end\n\n  def next_steps(%{board: board, size: size}) do\n    row = length(board) + 1\n\n    1..size\n    |> Enum.filter(fn col -> valid_position?(board, {row, col}) end)\n    |> Enum.map(fn col -> %{board: [{row, col} | board], size: size} end)\n  end\n\n  defp valid_position?(board, {row, col}) do\n    Enum.all?(board, fn {r, c} ->\n      c != col && abs(c - col) != abs(r - row)\n    end)\n  end\nend\n```","ref":"readme.html#defining-a-problem"},{"type":"extras","title":"Finding Solutions - Backfish","doc":"Use `Backfish.find_first_solution/2` to find the first valid solution or `Backfish.find_all_solutions/2` to find all possible solutions.\n\n#### Example: Solving N-Queens\n\n``` elixir\nopts = [args: [size: 8]]\n\n{:ok, solution} = Backfish.find_first_solution(Backfish.Examples.NQueens, opts)\nIO.inspect(solution)\n\nsolutions = Backfish.find_all_solutions(Backfish.Examples.NQueens, opts)\nIO.inspect(length(solutions))\n```","ref":"readme.html#finding-solutions"},{"type":"extras","title":"Additional Examples - Backfish","doc":"- [Eight Puzzle](lib/backfish/examples/eight_puzzle.ex)\n- [Graph Coloring](lib/backfish/examples/graph_coloring.ex)\n- [Hamiltonian Path](lib/backfish/examples/hamiltonian_path.ex)\n- [Knapsack](lib/backfish/examples/knapsack.ex)\n- [Sudoku](lib/backfish/examples/sudoku.ex)\n- [Word Search](lib/backfish/examples/word_search.ex)","ref":"readme.html#additional-examples"},{"type":"extras","title":"Contributing - Backfish","doc":"Contributions to improve Backfish are welcome. Please fork the repository and submit pull requests.","ref":"readme.html#contributing"},{"type":"extras","title":"Documentation - Backfish","doc":"Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found [here](https://hexdocs.pm/backfish).","ref":"readme.html#documentation"},{"type":"extras","title":"License - Backfish","doc":"Backfish is released under the [MIT License](LICENSE).","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}